#Boa:Dialog:loadDialog

from wxPython.wx import *
from data_fake import *
from __future__ import generators
from Thuban.Model import wellknowntext
from Thuban.Model.postgisdb import PostGISShape
from Thuban.Model.table import *
from dbFactory import *



def create(parent):
    return loadDialog(parent)

[wxID_LOADDIALOG, wxID_LOADDIALOGBOXTIEFE, wxID_LOADDIALOGBTN_CANCEL, 
 wxID_LOADDIALOGBTN_OK, wxID_LOADDIALOGGROUPBOX, wxID_LOADDIALOGLBLANWEISUNG, 
 wxID_LOADDIALOGLBLBESCHREIBGROUP, wxID_LOADDIALOGLBLBESCHREIBUNGSCHLAG, 
 wxID_LOADDIALOGLISTGROUP, wxID_LOADDIALOGLISTSCHLAG, 
 wxID_LOADDIALOGLISTTIEFE, wxID_LOADDIALOGSCHLAGBOX, 
 wxID_LOADDIALOGTXTANWEISUNG, wxID_LOADDIALOGTXTBESCHREIBUNGGROUP, 
 wxID_LOADDIALOGTXTBESCHREIBUNGSCHLAG, 
] = map(lambda _init_ctrls: wxNewId(), range(15))

class loadDialog(wxDialog):
    def _init_sizers(self):
        # generated method, don't edit
        self.boxSizer1 = wxBoxSizer(orient=wxVERTICAL)

    def _init_ctrls(self, prnt):
        # generated method, don't edit
        wxDialog.__init__(self, id=wxID_LOADDIALOG, name='loadDialog',
              parent=prnt, pos=wxPoint(440, 292), size=wxSize(625, 416),
              style=wxDEFAULT_DIALOG_STYLE, title='Layer aus DB Laden')
        self.SetClientSize(wxSize(625, 416))

        self.schlagBox = wxStaticBox(id=wxID_LOADDIALOGSCHLAGBOX,
              label='Schlag', name='schlagBox', parent=self, pos=wxPoint(32,
              16), size=wxSize(376, 184), style=0)

        self.groupBox = wxStaticBox(id=wxID_LOADDIALOGGROUPBOX, label='Gruppe',
              name='groupBox', parent=self, pos=wxPoint(32, 216),
              size=wxSize(376, 192), style=0)

        self.boxTiefe = wxStaticBox(id=wxID_LOADDIALOGBOXTIEFE, label='Tiefe',
              name='boxTiefe', parent=self, pos=wxPoint(424, 16),
              size=wxSize(180, 184), style=0)

        self.listSchlag = wxListBox(choices=[], id=wxID_LOADDIALOGLISTSCHLAG,
              name='listSchlag', parent=self, pos=wxPoint(40, 32),
              size=wxSize(200, 160), style=wxVSCROLL | wxLB_SINGLE)
        EVT_LISTBOX(self.listSchlag, wxID_LOADDIALOGLISTSCHLAG,
              self.OnListSchlagListbox)

        self.lblBeschreibungSchlag = wxStaticText(id=wxID_LOADDIALOGLBLBESCHREIBUNGSCHLAG,
              label='Beschreibung', name='lblBeschreibungSchlag', parent=self,
              pos=wxPoint(250, 32), size=wxSize(77, 16), style=0)

        self.txtBeschreibungSchlag = wxTextCtrl(id=wxID_LOADDIALOGTXTBESCHREIBUNGSCHLAG,
              name='txtBeschreibungSchlag', parent=self, pos=wxPoint(250, 56),
              size=wxSize(152, 136),
              style=wxTE_READONLY | wxVSCROLL | wxNO_3D | wxTE_LINEWRAP | wxTE_MULTILINE,
              value='Beschreibung')

        self.listTiefe = wxListBox(choices=[], id=wxID_LOADDIALOGLISTTIEFE,
              name='listTiefe', parent=self, pos=wxPoint(440, 32),
              size=wxSize(153, 160), style=wxVSCROLL | wxLB_MULTIPLE)
        EVT_LISTBOX(self.listTiefe, wxID_LOADDIALOGLISTTIEFE,
              self.OnListTiefeListbox)

        self.btn_ok = wxButton(id=wxID_LOADDIALOGBTN_OK, label='OK',
              name='btn_ok', parent=self, pos=wxPoint(416, 360), size=wxSize(80,
              40), style=0)
        EVT_BUTTON(self.btn_ok, wxID_LOADDIALOGBTN_OK, self.OnBtn_okButton)

        self.btn_cancel = wxButton(id=wxID_LOADDIALOGBTN_CANCEL, label='Cancel',
              name='btn_cancel', parent=self, pos=wxPoint(512, 360),
              size=wxSize(80, 40), style=0)
        EVT_BUTTON(self.btn_cancel, wxID_LOADDIALOGBTN_CANCEL,
              self.OnBtn_cancelButton)

        self.listGroup = wxListBox(choices=[], id=wxID_LOADDIALOGLISTGROUP,
              name='listGroup', parent=self, pos=wxPoint(40, 240),
              size=wxSize(200, 160), style=0)
        EVT_LISTBOX(self.listGroup, wxID_LOADDIALOGLISTGROUP,
              self.OnListGroupListbox)

        self.lblBeschreibGroup = wxStaticText(id=wxID_LOADDIALOGLBLBESCHREIBGROUP,
              label='Beschreibung', name='lblBeschreibGroup', parent=self,
              pos=wxPoint(255, 240), size=wxSize(77, 16), style=0)

        self.txtBeschreibungGroup = wxTextCtrl(id=wxID_LOADDIALOGTXTBESCHREIBUNGGROUP,
              name='txtBeschreibungGroup', parent=self, pos=wxPoint(250, 264),
              size=wxSize(153, 136), style=wxTE_READONLY | wxTE_MULTILINE,
              value='Beschreibung')

        self.lblAnweisung = wxStaticText(id=wxID_LOADDIALOGLBLANWEISUNG,
              label='Anweisung', name='lblAnweisung', parent=self,
              pos=wxPoint(425, 220), size=wxSize(62, 16), style=0)

        self.txtAnweisung = wxTextCtrl(id=wxID_LOADDIALOGTXTANWEISUNG,
              name='txtAnweisung', parent=self, pos=wxPoint(424, 240),
              size=wxSize(170, 48), style=wxTE_READONLY | wxTE_MULTILINE,
              value='Tipp')

        self._init_sizers()

    def __init__(self, parent,args=None):
       
        self._init_ctrls(parent)
        self.result=None
        self.dbfact = DbFactory.getDbFactory()
        schlaege = self.dbfact.dbSchlagAll()
        
        self.fillSchlagBox(schlaege)
        self.updateAnweisung("Bitte waehlen sie den entsprechenden Schalg aus")
        
        
        
        
        
    def fillSchlagBox(self,schlaege):
        
        if (schlaege==None):
            return
        if len(schlaege)==0:
            return
        theValues = [ "%s, %s" %(i.schlagid,i.name)  for i in schlaege ]
        self.schlaege=schlaege
        self.listSchlag.InsertItems(theValues,0)
        self.setSchlag(self.schlaege[0])
        
            
            
    def OnListSchlagListbox(self, event):
        index = self.listSchlag.GetSelection()
        self.setSchlag(self.schlaege[index])
        self.updateAnweisung("Bitte waehlen sie die entsprechende Gruppe aus")
        
                                                                                    
        
        event.Skip()

    def setSchlag(self,schlag):
        self.derSchlag=schlag
        self.updateSchlagBeschreibung()
        self.fillTiefenBox()
        self.fillGruppenBox()
        
    
    def updateSchlagBeschreibung(self):
        parents = self.dbfact.getVorfahrFromSchlagID(self.derSchlag.schlagid)
        parentStr =""
        for schlag in parents:
            parentStr += "%s, %s\n" %(schlag.schlagid,schlag.name)
            
        self.txtBeschreibungSchlag.SetValue("ID:%d\nName:%s\nDatum:%s\nEltern:%s\n"%(self.derSchlag.schlagid,
                                                                                    self.derSchlag.name,
                                                                                    self.derSchlag.datum,
                                                                                    parentStr))
                                                                                    
    def updateGruppenBeschreibung(self):
        self.txtBeschreibungGroup.SetValue("ID:%d\nName:%s\nDatum:%s\n\n%s"%(self.selGruppen[0].gruppenid,
                                                                                    self.selGruppen[0].name,
                                                                                    self.selGruppen[0].datum,
                                                                                    self.selGruppen[0].beschreibung))
    
    def updateAnweisung(self,text):
        self.txtAnweisung.SetValue(text)
    def fillTiefenBox(self):
        self.tiefen = self.dbfact.dbTiefenFromSchlagId(self.derSchlag.schlagid)
        theValues = [ "%s" %(i.tiefe)  for i in self.tiefen ]
        self.listTiefe.Clear()
        self.listTiefe.InsertItems(theValues,0)
        self.setTiefen(self.tiefen)
                
    def setTiefen(self,tiefen):
        # tiefen muss eine Listen von tiefen-Objekten sein
        self.selTiefen=tiefen
        
        
        
    def fillGruppenBox(self):
        self.gruppen = self.dbfact.dbGruppeFromSchlag(self.derSchlag.schlagid)
        theValues = [ "%s: %s" %(i.gruppenid,i.name)  for i in self.gruppen ]
        self.listGroup.Clear()
        self.listGroup.InsertItems(theValues,0)
        self.setGruppen([self.gruppen[0]])
        
    def setGruppen(self,gruppen):
        self.selGruppen=gruppen
        if (len(self.selGruppen)==1):
            self.updateGruppenBeschreibung()
        else:
            self.txtBeschreibungGroup.setValue("")
        
        
    
    def OnListTiefeListbox(self, event):
        anz = self.listTiefe.GetCount()
        list=[]
        for i in range(anz):
            if self.listTiefe.Selected(i):
                list.append(self.tiefen[i])
        self.setTiefen(list)
        
        self.updateAnweisung("OK sie koennen bestaetigen")
        event.Skip()

    def OnBtn_okButton(self, event):
        self.result=(self.derSchlag,self.selGruppen,self.selTiefen)
        self.Close()
        event.Skip()

    def OnBtn_cancelButton(self, event):
        self.result=None
        self.Close()
        event.Skip()

    def OnListGroupListbox(self, event):
        self.updateAnweisung("Bitte waehlen sie den entsprechenden Tiefen aus(STRG gedruekt halten)")
        self.setGruppen( [ self.gruppen[ event.GetInt()] ])
        event.Skip()

    def RunDialog(self):
        self.ShowModal()
        self.Destroy()
        return self.result
