
FEHLER_GLEICHE_PUNKTE = 1
FEHLER_NULLVEKTOR = 2
FEHLER_MIN_WERT_GLEICH_MAX_WERT = 3
FEHLER_ALLG_RECHENFEHLER = 4
FEHLER_FALSCHE_PROJEKTION = 5
FEHLER_POLYGON_OFFEN = 6
FEHLER_UNBEKANNTER_FEHLER = 255

standardFehler = { FEHLER_GLEICHE_PUNKTE:"zwei oder mehr Punkte mit identischen Koordinaten wurden in der Punktemenge gefunden",
                   FEHLER_NULLVEKTOR:"Vektor zwischen zwei Punkten hat die Laenge null - Punkte liegen auf einander",
                   FEHLER_MIN_WERT_GLEICH_MAX_WERT:"ein Normierungsfehler ist aufgetreten: der minimale und der maximale Wert von mindestens einem Attribut ist gleich", 
                   FEHLER_ALLG_RECHENFEHLER:"schwerer Fehler bei der Berechnung des Diagramms",
                   FEHLER_FALSCHE_PROJEKTION:"geom. Werte liegen in einem unzulaessigen Bereich - bitte stellen Sie sicher, dass die Werte in der Gauss-Krueger Darstellung vorliegen.",
                   FEHLER_POLYGON_OFFEN:"das Polygon ist nicht geschlossen",
                   FEHLER_UNBEKANNTER_FEHLER:"ein unbekannter Fehler ist aufgetreten" }

class fehler:
    def __init__( self, meldung = "", code = 0 ):
        if code != 0 and code in standardFehler.keys():
            self.meldung = standardFehler[code]
        elif meldung != "":
            self.meldung = meldung
        else:
            self.meldung = standardFehler[FEHLER_UNBEKANNTER_FEHLER]
        
    def __str__( self ):
        return self.meldung
