import math

# schleifen beschleunigen
try:
    from psyco.classes import __metaclass__
except:
    pass


x_komponente = 0
y_komponente = 1
z_komponente = 2
z1_komponente = 3

class feld_sortierer:
    def __init__(self, feld):
        self.punktefeld = feld
        self.sortier_Kriterium = x_komponente
        self.sortiert = False
        self.sortiertNach = -1
        
    def sortiertesFeld(self):
        self.sortiere( 0, len(self.punktefeld)-1 )
        return self.punktefeld

    def mische( self, start, trennung, ende ):
        """
        verschmelze zwei benachbarte Punktefolgen zu einer einzigen
        """
        # verschiedene Indices:
        start = int(start)
        trennung = int(trennung)
        ende = int(ende)
        i = int(start)
        j = int(trennung + 1)
        k = int(0)

        ergebnisfolge = []

        for z in range( ende - start + 1 ):
            ergebnisfolge.append("initialer Wert")

        while i <= trennung and j <= ende:
            if self.punktefeld[i].komponente( self.sortier_Kriterium ) <= self.punktefeld[j].komponente( self.sortier_Kriterium ):
                ergebnisfolge[k] = self.punktefeld[i]
                i += 1
            else:
                ergebnisfolge[k] = self.punktefeld[j]
                j += 1
            k += 1
        
        if i > trennung:
            for z in range( j, ende + 1):
                ergebnisfolge[k] = self.punktefeld[z]
                k += 1
        else:
            for z in range( i, trennung + 1 ):
                ergebnisfolge[k] = self.punktefeld[z]
                k += 1

        for z in range( start, ende+1 ):
            self.punktefeld[z] = ergebnisfolge[z-start]
            
    def sortiere( self, von, bis ):
        """
        merge sort: teilt solange, rekursiv auf, bis jeweils nur ein Element zu sortieren ist und fuegt
        dann alle Elemente wieder zu einer Gesamt folge zusammen
        """
        if ( von < bis ):
            trenner = math.floor( ( von + bis ) / 2 )
            self.sortiere( von, trenner )
            self.sortiere( trenner+1, bis )
            self.mische( von, trenner, bis )

            if von==0 and bis == len( self.punktefeld )-1:
                self.sortiert = True
                self.sortiertNach = self.sortier_Kriterium
