# schleifen beschleunigen
try:
    from psyco.classes import __metaclass__
except:
    pass

class string2nestedlist:
    """
    Klasse, die die string Repraesentation einer list oder/und eines tuples, bzw
    eine beliebiege verschachtelung beider wieder in ein entsprechendes Objekt umsetzt.
    """
    
    def __init__(self, str, verbose = False):
        self.string = str
        self.verbose = verbose
        
    def parseString2nestedList( self ):
        return self._parseTeilstring( self.string )
        
    def _parseTeilstring( self, tstr ):
        tstr = tstr.lstrip()
        tstr = tstr.rstrip()
        
        typ = -1
        valuesContainer = None
        result = None
        
        posErstesArray = tstr.find( "[" )
        posErstesTuple = tstr.find( "(" )
        
        if ( posErstesArray < 0 and posErstesTuple < 0 or 
            (tstr.startswith( "[" )==False and tstr.startswith( "(" )==False) ):
            return self._parseValues( tstr )
        elif ( tstr.startswith( "[" ) or posErstesTuple < 0 ):
            # Array
            typ = 0
            if ( self.verbose ):
                print "----------"
                print "vorher: ", tstr
            tstr = tstr[posErstesArray+1:]
            tstr = tstr[:tstr.rindex("]")]
            if ( self.verbose ):
                print "nachher: ", tstr
            valuesContainer = self._parseValues( tstr )
            result = valuesContainer
        elif ( tstr.startswith( "(" ) or posErstesArray < 0 ):
            # Tuple
            typ = 1
            if ( self.verbose ):
                print "----------"
                print "vorher: ", tstr
            tstr = tstr[posErstesTuple+1:]
            tstr = tstr[:tstr.rindex(")")]
            if ( self.verbose ):
                print "nachher: ", tstr
            valuesContainer = self._parseValues( tstr )
            result = tuple( valuesContainer )
        else:
            print "kann string nicht parsen: ", tstr
            
        return result
            
    def _parseValues( self, valsStr ):
        """
        returns list of values
        die koennen dann ggf. in ein tuple umgewandelt werden
        """
        valsStr = valsStr.lstrip()
        valsStr = valsStr.rstrip()
        tmp = self._splitStr( valsStr, "," )
        result = []
        
        for val in tmp:
            result.append( self._parseValue( val ) )
            
        return result
        
    def _splitStr( self, str, delemiter ):
        if ( str.find("[") < 0 and str.find("(") < 0 ):
            return str.split( delemiter )
        else:
            # string enthaelt liste von arrays oder tuples
            if ( self.verbose ):
                print "vor _splitStr(): ", str
            result = []
            
            while ( len(str) > 0  ):
                for pos in range( len(str) +1 ):
                    if ( pos > 0 and 
                        str.count( "[", 0, pos ) == str.count( "]", 0, pos ) and 
                        str.count( "(", 0, pos ) == str.count( ")", 0, pos ) and 
                        ( str.count( "[", 0, pos )!=0 or str.count( "(", 0, pos )!=0) ):
                        teil = str[ :pos ]
                        teil = teil.lstrip(" ")
                        teil = teil.rstrip(" ")
                        teil = teil.lstrip(delemiter)
                        teil = teil.rstrip(delemiter)
                        teil = teil.lstrip(" ")
                        teil = teil.rstrip(" ")
                        if ( len(teil) > 0 ):
                            result.append( teil )
                            #print "appending: <", teil, ">"
                        str = str[ pos: ]
                        break
                str = str.lstrip()
                str = str.rstrip()
                str = str.lstrip(delemiter)
                str = str.rstrip(delemiter)
                str = str.lstrip()
                str = str.rstrip()
            return result
                    
    def _parseValue( self, valStr ):
        valStr = valStr.lstrip(" ")
        valStr = valStr.rstrip(" ")
        
        if ( valStr.isdigit() or 
            ( valStr.count(".") == 1 and 
                    (valStr[:valStr.find(".")].isdigit() or ( valStr.startswith("-") and valStr[1:valStr.find(".")].isdigit()))
                    and valStr[valStr.find(".")+1:].isdigit() )
            ):
            # Zahl
            if ( valStr.find(".") > -1 ):
                return float( valStr )
            else:
                return int( valStr )
        elif ( valStr.find("[") > -1 or valStr.find("(") > -1 ):
            # list oder tuple?
            return self._parseTeilstring( valStr )
        elif ( valStr.startswith("'") ):
            # String?
            if ( valStr.startswith("'") ):
                valStr = valStr.lstrip("'")
                valStr = valStr.rstrip("'")
            
            return valStr
        else:
            print "kann wert nicht aufloesen: <", valStr, ">"
            return valStr
        
