#Boa:Dialog:SaveDialog

from wxPython.wx import *
from data_fake import *
from __future__ import generators
from Thuban.Model import wellknowntext
from Thuban.Model.postgisdb import PostGISShape
from Thuban.Model.table import *
from dbFactory import *
from derivedTables import *
from Thuban.Model.proj import Projection, ProjFile
from convHull import *
from mx import DateTime
from thread import *
from Thuban.Model.resource import get_user_proj_file, get_system_proj_file, \
                                  read_proj_file, write_proj_file, get_user_proj_file, \
                                  DEFAULT_PROJ_FILE, EPSG_PROJ_FILE, \
                                  EPSG_DEPRECATED_PROJ_FILE

def create(parent):
    return SaveDialog(parent)

[wxID_SAVEDIALOG, wxID_SAVEDIALOGBOX_GRUPPE, wxID_SAVEDIALOGBOX_PROJEKTION, 
 wxID_SAVEDIALOGBOX_SCHLAG, wxID_SAVEDIALOGBOX_TIEFEN, 
 wxID_SAVEDIALOGBTN_CANCEL, wxID_SAVEDIALOGBTN_ENTFERNEN, 
 wxID_SAVEDIALOGBTN_HINZU, wxID_SAVEDIALOGBTN_OK, 
 wxID_SAVEDIALOGBTN_VERKUEPFEN, wxID_SAVEDIALOGCHECKLISTBOX_SCHLAGPARENT, 
 wxID_SAVEDIALOGCHECKLISTBOX_TIEFENATTRIBUTE, wxID_SAVEDIALOGCHOICEPROJ, 
 wxID_SAVEDIALOGCHOICE_GRUPPENJAHR, wxID_SAVEDIALOGCHOICE_GRUPPENMINUTE, 
 wxID_SAVEDIALOGCHOICE_GRUPPENMONAT, wxID_SAVEDIALOGCHOICE_GRUPPENSTUNDE, 
 wxID_SAVEDIALOGCHOICE_GRUPPENTAG, wxID_SAVEDIALOGCHOICE_SCHLAGJAHR, 
 wxID_SAVEDIALOGCHOICE_SCHLAGMINUTE, wxID_SAVEDIALOGCHOICE_SCHLAGMONAT, 
 wxID_SAVEDIALOGCHOICE_SCHLAGSTUNDE, wxID_SAVEDIALOGCHOICE_SCHLAGTAG, 
 wxID_SAVEDIALOGLBL_GRUPPENDATUM, wxID_SAVEDIALOGLBL_GRUPPENNAME, 
 wxID_SAVEDIALOGLBL_GRUPPENZEIT, wxID_SAVEDIALOGLBL_NEUETIEFE, 
 wxID_SAVEDIALOGLBL_ORIGDATA, wxID_SAVEDIALOGLBL_SCHLAGDATUM, 
 wxID_SAVEDIALOGLBL_SCHLAGNAME, wxID_SAVEDIALOGLBL_SCHLAGPARENT, 
 wxID_SAVEDIALOGLBL_SCHLAGZEIT, wxID_SAVEDIALOGLBL_TIEFENBESCHREIBUNG, 
 wxID_SAVEDIALOGLBL_VORSCHAU, wxID_SAVEDIALOGLISTBOX_TIEFEN, 
 wxID_SAVEDIALOGLISTCTRL_PROJECTION, wxID_SAVEDIALOGTXT_GRUPPENBESCHREIBUNG, 
 wxID_SAVEDIALOGTXT_GRUPPENNAME, wxID_SAVEDIALOGTXT_NEUETIEFE, 
 wxID_SAVEDIALOGTXT_ORIGINALDATEN, wxID_SAVEDIALOGTXT_SCHLAGNAME, 
 wxID_SAVEDIALOGTXT_VORSCHAU, 
] = map(lambda _init_ctrls: wxNewId(), range(42))

class SaveDialog(wxDialog):
    def _init_ctrls(self, prnt):
        # generated method, don't edit
        wxDialog.__init__(self, id=wxID_SAVEDIALOG, name='SaveDialog',
              parent=prnt, pos=wxPoint(230, 310), size=wxSize(926, 593),
              style=wxDEFAULT_DIALOG_STYLE, title='Save Layer to DB')
        self.SetClientSize(wxSize(926, 593))

        self.box_schlag = wxStaticBox(id=wxID_SAVEDIALOGBOX_SCHLAG,
              label='Schlag', name='box_schlag', parent=self, pos=wxPoint(13,
              5), size=wxSize(563, 171), style=0)

        self.checkListBox_SchlagParent = wxCheckListBox(choices=[],
              id=wxID_SAVEDIALOGCHECKLISTBOX_SCHLAGPARENT,
              name='checkListBox_SchlagParent', parent=self, pos=wxPoint(368,
              40), size=wxSize(192, 120), style=0)

        self.lbl_SchlagParent = wxStaticText(id=wxID_SAVEDIALOGLBL_SCHLAGPARENT,
              label='Hervorgegangen aus', name='lbl_SchlagParent', parent=self,
              pos=wxPoint(400, 15), size=wxSize(118, 16), style=0)

        self.lbl_SchlagName = wxStaticText(id=wxID_SAVEDIALOGLBL_SCHLAGNAME,
              label='Name', name='lbl_SchlagName', parent=self, pos=wxPoint(20,
              20), size=wxSize(32, 16), style=0)

        self.txt_SchlagName = wxTextCtrl(id=wxID_SAVEDIALOGTXT_SCHLAGNAME,
              name='txt_SchlagName', parent=self, pos=wxPoint(90, 15),
              size=wxSize(150, 20), style=0, value='SchlagName')

        self.lbl_SchlagDatum = wxStaticText(id=wxID_SAVEDIALOGLBL_SCHLAGDATUM,
              label='Datum', name='lbl_SchlagDatum', parent=self,
              pos=wxPoint(20, 45), size=wxSize(35, 16), style=0)

        self.choice_SchlagTag = wxChoice(choices=[],
              id=wxID_SAVEDIALOGCHOICE_SCHLAGTAG, name='choice_SchlagTag',
              parent=self, pos=wxPoint(88, 40), size=wxSize(80, 30), style=0)

        self.choice_SchlagMonat = wxChoice(choices=[],
              id=wxID_SAVEDIALOGCHOICE_SCHLAGMONAT, name='choice_SchlagMonat',
              parent=self, pos=wxPoint(176, 40), size=wxSize(80, 30), style=0)

        self.choice_SchlagJahr = wxChoice(choices=[],
              id=wxID_SAVEDIALOGCHOICE_SCHLAGJAHR, name='choice_SchlagJahr',
              parent=self, pos=wxPoint(264, 40), size=wxSize(80, 30), style=0)

        self.lbl_SchlagZeit = wxStaticText(id=wxID_SAVEDIALOGLBL_SCHLAGZEIT,
              label='Zeit', name='lbl_SchlagZeit', parent=self, pos=wxPoint(20,
              84), size=wxSize(22, 16), style=0)

        self.choice_SchlagStunde = wxChoice(choices=[],
              id=wxID_SAVEDIALOGCHOICE_SCHLAGSTUNDE, name='choice_SchlagStunde',
              parent=self, pos=wxPoint(88, 80), size=wxSize(80, 30), style=0)

        self.choice_SchlagMinute = wxChoice(choices=[],
              id=wxID_SAVEDIALOGCHOICE_SCHLAGMINUTE, name='choice_SchlagMinute',
              parent=self, pos=wxPoint(176, 80), size=wxSize(80, 30), style=0)

        self.box_Gruppe = wxStaticBox(id=wxID_SAVEDIALOGBOX_GRUPPE,
              label='GruppenInfo', name='box_Gruppe', parent=self,
              pos=wxPoint(13, 184), size=wxSize(563, 195), style=0)

        self.lbl_GruppenName = wxStaticText(id=wxID_SAVEDIALOGLBL_GRUPPENNAME,
              label='Name', name='lbl_GruppenName', parent=self, pos=wxPoint(20,
              216), size=wxSize(32, 16), style=0)

        self.lbl_GruppenDatum = wxStaticText(id=wxID_SAVEDIALOGLBL_GRUPPENDATUM,
              label='Datum', name='lbl_GruppenDatum', parent=self,
              pos=wxPoint(20, 252), size=wxSize(35, 16), style=0)

        self.txt_GruppenName = wxTextCtrl(id=wxID_SAVEDIALOGTXT_GRUPPENNAME,
              name='txt_GruppenName', parent=self, pos=wxPoint(80, 216),
              size=wxSize(160, 22), style=0, value='GruppenName')

        self.lbl_GruppenZeit = wxStaticText(id=wxID_SAVEDIALOGLBL_GRUPPENZEIT,
              label='Zeit', name='lbl_GruppenZeit', parent=self, pos=wxPoint(20,
              294), size=wxSize(22, 16), style=0)

        self.choice_GruppenTag = wxChoice(choices=[],
              id=wxID_SAVEDIALOGCHOICE_GRUPPENTAG, name='choice_GruppenTag',
              parent=self, pos=wxPoint(80, 248), size=wxSize(80, 30), style=0)

        self.choice_GruppenMonat = wxChoice(choices=[],
              id=wxID_SAVEDIALOGCHOICE_GRUPPENMONAT, name='choice_GruppenMonat',
              parent=self, pos=wxPoint(168, 248), size=wxSize(80, 30), style=0)

        self.choice_GruppenJahr = wxChoice(choices=[],
              id=wxID_SAVEDIALOGCHOICE_GRUPPENJAHR, name='choice_GruppenJahr',
              parent=self, pos=wxPoint(264, 248), size=wxSize(80, 30), style=0)

        self.choice_GruppenMinute = wxChoice(choices=[],
              id=wxID_SAVEDIALOGCHOICE_GRUPPENMINUTE,
              name='choice_GruppenMinute', parent=self, pos=wxPoint(168, 288),
              size=wxSize(80, 30), style=0)

        self.choice_GruppenStunde = wxChoice(choices=[],
              id=wxID_SAVEDIALOGCHOICE_GRUPPENSTUNDE,
              name='choice_GruppenStunde', parent=self, pos=wxPoint(80, 288),
              size=wxSize(80, 30), style=0)

        self.txt_GruppenBeschreibung = wxTextCtrl(id=wxID_SAVEDIALOGTXT_GRUPPENBESCHREIBUNG,
              name='txt_GruppenBeschreibung', parent=self, pos=wxPoint(368,
              232), size=wxSize(192, 128), style=wxTE_MULTILINE,
              value='Beschreibung')

        self.lbl_TiefenBeschreibung = wxStaticText(id=wxID_SAVEDIALOGLBL_TIEFENBESCHREIBUNG,
              label='Beschreibung', name='lbl_TiefenBeschreibung', parent=self,
              pos=wxPoint(408, 216), size=wxSize(77, 16), style=0)

        self.box_tiefen = wxStaticBox(id=wxID_SAVEDIALOGBOX_TIEFEN,
              label='Tiefen', name='box_tiefen', parent=self, pos=wxPoint(16,
              384), size=wxSize(560, 208), style=0)

        self.checkListBox_TiefenAttribute = wxCheckListBox(choices=[],
              id=wxID_SAVEDIALOGCHECKLISTBOX_TIEFENATTRIBUTE,
              name='checkListBox_TiefenAttribute', parent=self, pos=wxPoint(360,
              400), size=wxSize(206, 176), style=0)
        EVT_CHECKLISTBOX(self.checkListBox_TiefenAttribute,
              wxID_SAVEDIALOGCHECKLISTBOX_TIEFENATTRIBUTE,
              self.OnCheckListBox_TiefenAttributeChecklistbox)
        EVT_LISTBOX(self.checkListBox_TiefenAttribute,
              wxID_SAVEDIALOGCHECKLISTBOX_TIEFENATTRIBUTE,
              self.OnCheckListBox_TiefenAttributeListbox)

        self.listBox_Tiefen = wxListBox(choices=[],
              id=wxID_SAVEDIALOGLISTBOX_TIEFEN, name='listBox_Tiefen',
              parent=self, pos=wxPoint(24, 408), size=wxSize(174, 80), style=0)
        EVT_LISTBOX_DCLICK(self.listBox_Tiefen, wxID_SAVEDIALOGLISTBOX_TIEFEN,
              self.OnListBox_TiefenListboxDclick)
        EVT_LISTBOX(self.listBox_Tiefen, wxID_SAVEDIALOGLISTBOX_TIEFEN,
              self.OnListBox_TiefenListbox)

        self.btn_verkuepfen = wxButton(id=wxID_SAVEDIALOGBTN_VERKUEPFEN,
              label='verknuepfen', name='btn_verkuepfen', parent=self,
              pos=wxPoint(240, 432), size=wxSize(80, 22), style=0)
        EVT_BUTTON(self.btn_verkuepfen, wxID_SAVEDIALOGBTN_VERKUEPFEN,
              self.OnBtn_verkuepfenButton)

        self.txt_NeueTiefe = wxTextCtrl(id=wxID_SAVEDIALOGTXT_NEUETIEFE,
              name='txt_NeueTiefe', parent=self, pos=wxPoint(30, 548),
              size=wxSize(60, 20), style=0, value='0')

        self.lbl_NeueTiefe = wxStaticText(id=wxID_SAVEDIALOGLBL_NEUETIEFE,
              label='NeueTiefe', name='lbl_NeueTiefe', parent=self,
              pos=wxPoint(30, 525), size=wxSize(57, 16), style=0)

        self.btn_hinzu = wxButton(id=wxID_SAVEDIALOGBTN_HINZU,
              label='hinzufuegen', name='btn_hinzu', parent=self,
              pos=wxPoint(24, 496), size=wxSize(80, 22), style=0)
        EVT_BUTTON(self.btn_hinzu, wxID_SAVEDIALOGBTN_HINZU,
              self.OnBtn_hinzuButton)

        self.btn_entfernen = wxButton(id=wxID_SAVEDIALOGBTN_ENTFERNEN,
              label='entfernen', name='btn_entfernen', parent=self,
              pos=wxPoint(120, 496), size=wxSize(80, 22), style=0)
        EVT_BUTTON(self.btn_entfernen, wxID_SAVEDIALOGBTN_ENTFERNEN,
              self.OnBtn_entfernenButton)

        self.box_Projektion = wxStaticBox(id=wxID_SAVEDIALOGBOX_PROJEKTION,
              label='Projektion', name='box_Projektion', parent=self,
              pos=wxPoint(584, 8), size=wxSize(328, 464), style=0)

        self.txt_OriginalDaten = wxTextCtrl(id=wxID_SAVEDIALOGTXT_ORIGINALDATEN,
              name='txt_OriginalDaten', parent=self, pos=wxPoint(600, 337),
              size=wxSize(295, 50), style=wxTE_READONLY | wxTE_MULTILINE,
              value='Original')

        self.lbl_OrigData = wxStaticText(id=wxID_SAVEDIALOGLBL_ORIGDATA,
              label='OriginalDaten', name='lbl_OrigData', parent=self,
              pos=wxPoint(601, 317), size=wxSize(77, 16), style=0)

        self.lbl_Vorschau = wxStaticText(id=wxID_SAVEDIALOGLBL_VORSCHAU,
              label='Vorschau', name='lbl_Vorschau', parent=self,
              pos=wxPoint(600, 395), size=wxSize(54, 16), style=0)

        self.txt_Vorschau = wxTextCtrl(id=wxID_SAVEDIALOGTXT_VORSCHAU,
              name='txt_Vorschau', parent=self, pos=wxPoint(600, 415),
              size=wxSize(295, 45), style=wxTE_READONLY | wxTE_MULTILINE,
              value='Vorschau')

        self.btn_ok = wxButton(id=wxID_SAVEDIALOGBTN_OK, label='OK',
              name='btn_ok', parent=self, pos=wxPoint(728, 552), size=wxSize(96,
              30), style=0)
        EVT_BUTTON(self.btn_ok, wxID_SAVEDIALOGBTN_OK, self.OnBtn_okButton)

        self.btn_cancel = wxButton(id=wxID_SAVEDIALOGBTN_CANCEL, label='Cancel',
              name='btn_cancel', parent=self, pos=wxPoint(600, 552),
              size=wxSize(96, 30), style=0)
        EVT_BUTTON(self.btn_cancel, wxID_SAVEDIALOGBTN_CANCEL,
              self.OnBtn_cancelButton)

        self.choiceProj = wxChoice(choices=[], id=wxID_SAVEDIALOGCHOICEPROJ,
              name='choiceProj', parent=self, pos=wxPoint(608, 32),
              size=wxSize(288, 30), style=0)
        EVT_CHOICE(self.choiceProj, wxID_SAVEDIALOGCHOICEPROJ,
              self.OnChoiceProjChoice)

        self.listCtrl_Projection = wxListCtrl(id=wxID_SAVEDIALOGLISTCTRL_PROJECTION,
              name='listCtrl_Projection', parent=self, pos=wxPoint(608, 80),
              size=wxSize(288, 216), style=wxHSCROLL | wxVSCROLL | wxLC_REPORT)
        EVT_LIST_ITEM_SELECTED(self.listCtrl_Projection,
              wxID_SAVEDIALOGLISTCTRL_PROJECTION,
              self.OnListCtrl_ProjectionListItemSelected)

    def __init__(self, parent,storeObject = None):
        self._init_ctrls(parent)
        self.main_window = parent
        self.__Projections=[]
        self.__projFiles=[]
        self.__selectedProj = None
        
        self.__outProj = Projection("+proj=tmerc +lat_0=0 +lon_0=9 +k=1.000000 +x_0=3500000 +y_0=0 +ellps=bessel +units=m".split())
        self.schlag = None
        self.result=None
        self.error = False
        self.__selTiefe = None
        self.tiefen = None
        self.__strTiefen= []
        self.__tiefenAttribMap = {}
        self.__attribColumnNames =[]
        self.__attribColumnTypes = []
        self.fertig=False
        
        
        
        if storeObject == None:
            self.error = True
        self.storeObject=storeObject
                
        self.dbfact = DbFactory.getDbFactory()
        projFile , msg = get_user_proj_file()
        self.__projFiles.append(projFile) 
        for projFileName in [DEFAULT_PROJ_FILE,EPSG_PROJ_FILE,EPSG_DEPRECATED_PROJ_FILE] :
            projFile , msg = get_system_proj_file(projFileName)
            self.__projFiles.append(projFile)
        
        # OK fuelle Projektionen
        self.__fillProjectionChoice()
        self.__ConvHull = convHull(storeObject)
        self.__initDates()
        self.__initAttribute()
        
       
    def Fertig(self):
        return self.fertig
    def Percent(self):
        return self.percent
    def OnBtn_verkuepfenButton(self, event):
        event.Skip()

    def OnBtn_hinzuButton(self, event):
        tiefe = self.txt_NeueTiefe.GetValue()
        if self.__tiefenAttribMap.has_key("%s"%tiefe):
            return
        
        self.listBox_Tiefen.Append(tiefe)
        self.__tiefenAttribMap ["%s"%tiefe]=[]
        self.__strTiefen.append("%s"%tiefe)
        self.__selTiefe=None
        self.__updateTiefenCheckListBox()
        event.Skip()

    def OnBtn_entfernenButton(self, event):
        temp = self.listBox_Tiefen.GetSelections()
        indices = list(temp)
        for i in indices:
            entry = self.listBox_Tiefen.GetString(i)
            self.listBox_Tiefen.Delete(i)
            del self.__tiefenAttribMap ["%s"%entry]
            del self.__strTiefen[i]
            
        self.__selTiefe=None
        self.__updateTiefenCheckListBox()
        event.Skip()

    def OnBtn_okButton(self, event):
        if self.checkParams():
            self.process()
            self.result = (self.theRootGeom,self.gruppe,self.schlag)
        self.Close()
        event.Skip()

    def OnBtn_cancelButton(self, event):
        event.Skip()
        self.result=None
        self.Close()
        

    def OnChoiceProjChoice(self, event):
        #Neue Auswahl der Projektion wurde getaetigt
        index = self.choiceProj.GetSelection()
        self.__UpdateProjectionList(index)
        event.Skip()

    def OnListCtrl_ProjectionListItemSelected(self, event):
        index = event.m_itemIndex
        if index == 0:
            self.__selectedProj= None
        else:
            self.__selectedProj = self.__Projections[index-1]
        self.__UpdatePreview()
        # Convexe huelle besogen
        convHull = self.__ConvHull.getHull()
        # ist nicht projeziert, also projezieren
        convHull = self.__projList(convHull)
        # sehr schoen, nun noch locker zurueckschieben in des objekt und schon mal den OgcString besorgen
        ogcHull = self.__ConvHull.getOgcHull(convHull)
        self.ogcHull = ogcHull
        self.__prepareSchlaglist(ogcHull)      
        event.Skip()
    
        
    def OnCheckListBox_TiefenAttributeChecklistbox(self, event):
        #print "Event CheckListBox %r checked %r Index %r  " %(event.GetString(),event.IsChecked(),event.GetInt())
        if self.__selTiefe == None :
            return
        
        if self.checkListBox_TiefenAttribute.IsChecked(event.GetInt()):
           # print "Check: Tiefe %r bekommt attrib mit index %r " %(self.__selTiefe,event.GetInt())
            self.__tiefenAttribMap["%s" %self.__selTiefe].append(event.GetInt())
        else:
            #print "UnCheck: In Tiefe %r wird attrib mit index %r entfernt " %(self.__selTiefe,event.GetInt())
            list =  self.__tiefenAttribMap["%s" %self.__selTiefe]
            #print "Liste %r" %list
            index = 0
            for i in list:
                if  i == event.GetInt():
                    #print "stelle %r entfernt %r" %(self.__selTiefe,i)
                    del self.__tiefenAttribMap["%s" %self.__selTiefe][index]
                index += 1
            
        event.Skip()

    def OnListBox_TiefenListboxDclick(self, event):
        #print "Event TiefenListBox DblClick %r " %event.GetString()
        
        event.Skip()

    def OnCheckListBox_TiefenAttributeListbox(self, event):
        #print "Event CheckListBox:ListBox %r  " %event.GetString()
        event.Skip()

    def OnListBox_TiefenListbox(self, event):
        #print "Event TiefenListBox %r index: %r " %(event.GetString(),event.GetInt())
        self.__selTiefe = self.__strTiefen[event.GetInt()]
        self.__updateTiefenCheckListBox()
        
        event.Skip()
    
    
    def RunDialog(self):
        if self.error :
            return None
        self.ShowModal()
        self.Destroy()
        return self.result
    
    def RunMessageBox(self,title,text,flags = wxOK | wxICON_INFORMATION):
        dlg = wxMessageDialog(self, text, title, flags)
        dlg.CenterOnParent()
        result = dlg.ShowModal()
        dlg.Destroy()
    
    
    def checkParams(self):
        # Testen ob alles da ist
        if (self.txt_SchlagName.GetValue() == "" ):
            self.RunMessageBox('SchlagName fehlt','Bitte geben Sie einen Schlagnamen ein!')
            return false
        if (self.txt_GruppenName.GetValue() == "" ):
            self.RunMessageBox('GruppenName fehlt', 'Bitte geben Sie einen Gruppennamen ein!')
            return false
        if (self.txt_GruppenBeschreibung.GetValue() == "" ):
            self.RunMessageBox('GruppenBeschreibung fehlt', 'Bitte geben Sie eine GruppenBeschreibung ein!')
            return false
        if ( len ( self.__tiefenAttribMap.keys()) <1 ):
            self.RunMessageBox('Tiefen nicht gewaehlt', 'Bitte ordnen sie die Attribute einer oder meheren Tiefen zu!')
            return false
        return True
        
    def process(self):
        # schlag speichern
        
        self.fertig = False
        parent = "NULL"
        datum = self.__getSchlagTimeStamp()
        root = "NULL"
        name = self.txt_SchlagName.GetValue()
        if self.schlag == None:
            schlag=DbSchlag(db=self.dbfact.db,logger=self.dbfact.logger,borderPoly=self.ogcHull,
                        datum=datum,name=name)
            schlag.save()
            self.schlag=schlag
        schlag = self.schlag
        # schlag ist wech dann die parents
        for i in range (self.checkListBox_SchlagParent.GetCount() ):
            if self.checkListBox_SchlagParent.IsChecked(i):
                einVorfahrSchlag = self.__parentSchlaege[i]
                tempVor = DbSchlagVorfahr(db=self.dbfact.db,logger=self.dbfact.logger,schlagid=self.schlag.schlagid,vorfahrid=einVorfahrSchlag.schlagid)
                print "Versuch Vorfahr %d %d zu speichern"
                tempVor.save()
                
                
        
        self.theRootGeom = DbGeom(db=self.dbfact.db,logger=self.dbfact.logger,
                    schlagid=self.schlag.schlagid,shapeid=0,parent="NULL",root="NULL")
        self.theRootGeom.save()
        time1 = self.__getGruppenTimeStamp()
        name = self.txt_GruppenName.GetValue()
        gruppe = DbGruppe(db=self.dbfact.db,logger=self.dbfact.logger,geomid=self.theRootGeom.geomid,
                           beschreibung=self.txt_GruppenBeschreibung.GetValue(),
                           datum = time1,
                           name = name )
        gruppe.save()
        self.gruppe=gruppe
        #tiefen  & Attriblisten speichern
        for strTiefe in self.__tiefenAttribMap.keys():
            tiefe = self.dbfact.dbTiefe(schlag.schlagid,strTiefe)
            if tiefe == None:
                tiefe = DbTiefe(db=self.dbfact.db,logger=self.dbfact.logger,tiefe=strTiefe,schlagid=schlag.schlagid)
            tiefe.save()
            
            neueAttributListe=DbAttributListe(db=self.dbfact.db,logger=self.dbfact.logger,name="Attribute in dieser Tiefe", description="keine Bechreibung vorhanden",schlagid=schlag.schlagid,tiefenid=tiefe.tiefenid)
            neueAttributListe.save()
            
            # nun in ner neuen Schleife alle Attribute
           
            
            list = self.__tiefenAttribMap[strTiefe]
            # list ist eine liste von indices der eintraege in self.checkListBox_TiefenAttribute
            oldAttribs =  self.dbfact.dbAttrributTyp(schlag.schlagid,tiefe.tiefenid)
            
            
            
            
            # fuer jeden Attributtyp sprich "HUMUS",PH".....
            # wird diese Schleife duchlaufen
            for index in list:
                derAttributTyp = None
                datatype = None
                # in attributTyp steht jetzt z.B. HUMUS
                attributTyp  = self.checkListBox_TiefenAttribute.GetString(index)
                print "process: AttTyp %s " %attributTyp
                # besorg mal den datentyp
                for index in range(len(self.__attribColumnNames)) :
                    if  self.__attribColumnNames[index] == attributTyp:
                        datatype = self.__attribColumnTypes[index]
                        break
                print "       Datatyp:%s" %datatype
                    
                for oldAttrib in oldAttribs:
                    #print "oldAttrib %s" %oldAttrib
                    # gibts z.B. HUMUS schon in dieser Tiefe auf diesem Schlag ?
                    if attributTyp == oldAttrib.typ:
                        # ja
                        print "        Attribut in der DB vorhanden %s" %oldAttrib.typ
                        derAttributTyp = oldAttrib
                        break
                if derAttributTyp == None:
                    derAttributTyp = DbAttributTyp ( db=self.dbfact.db,
                                                     logger=self.dbfact.logger,
                                                     tiefenid=tiefe.tiefenid,
                                                     schlagid=schlag.schlagid,
                                                     typ=attributTyp,
                                                     time="%s" %DateTime.now(),
                                                     rasterid="NULL",
                                                     datatype=datatype)
                
                if derAttributTyp==None:
                    print "Big Problem"
                else:
                    derAttributTyp.save()
            
            ## weiter gehts
            # alle geoms erzeugen
            
        progressBar = wxProgressDialog("Bitte warten", "Layer wird gespeichert", 100, self, wxPD_AUTO_HIDE)
        threadfunc = self.__saveAll
        self.fertig=False
        identifier = start_new_thread(threadfunc,tuple())
        while not self.Fertig():
            sleep(0.1)
            progressBar.Update( int(self.Percent()) )
        progressBar.Update( 100 )
        self.fertig=False
        self.percent = 0
        self.dbfact.db.commit()
            
        
            
            
    def __saveAll(self):
        self.__prepareGeoms()
        length = len (self.attribs)
        rowcount = 0
        for geom in self.geoms:
            rowcount += 1
            if ( length != 0 ):
                self.percent = 50 + (25.0/length)*rowcount
            else:
                self.percent = 50 + 50
            geom.save()
        length = len (self.attribs)
        rowcount = 0
        for attrib in self.attribs :
            rowcount += 1
            self.percent = 75 + (25.0/length)*rowcount
            attrib.save()
        self.fertig = True
        
    def __prepareGeoms(self):
        # geoms erzeugen fuer alle schapes 
        #attribut erzeugen fuer alle eintaege im Shapetable
        attribtiefenlist = self.dbfact.attribtiefenlist(self.schlag.schlagid)
        
        shapetype = self.storeObject.ShapeType()
        table = self.storeObject.Table()
        
        ogcString ="SRID=-1;"
        ogcEnd=""
        buildString=""
        evalstr = ""
        params ="logger=self.dbfact.logger,db=self.dbfact.db,schlagid=self.schlag.schlagid,root=self.theRootGeom.geomid,shapeid=shape.ShapeID(),parent=\"NULL\",geom="
        self.geoms=[]
        self.attribs=[]
        if shapetype == "point":
            ogcString += "POINT("
            ogcEnd = ")"
            evalstr = "DbGeomPoint(%s"%params
            
        elif shapetype == "arc":
            ogcString += "MULTILINESTING(("
            ogcEnd = "))"
            evalstr = "DbGeomMultiLineString(%s"%params
        elif shapetype == "polygon":
            ogcString += "MULTIPOLYGON(((%"
            ogcEnd = ")))"
            evalstr = "DbGeomMultiPoly(%s"%params
        
        
        length = self.storeObject.NumShapes()
        rowcount = 0
        for shape in self.storeObject.AllShapes():
            rowcount += 1
            self.percent = (50.0/length)*rowcount
            evalString = evalstr 
            buildString = ogcString
            for vert in shape.Points():
                for p in vert:
                    buildString += "%r %r,"%self.__proj(p)
            buildString = "\""+ buildString[:-1]+ogcEnd+"\")"
            evalString += buildString
            aGeom = eval(evalString)
            self.geoms.append(aGeom)
            # ok every geom will be build
            # now build the matching Atrribute
            result = table.ReadRowAsDict( int(shape.ShapeID()))
            for attribname in result.keys():
                if not attribtiefenlist.has_key(attribname):
                    continue
                if not self.__findAttribInSelfTiefenAttribMap(attribname):
                    continue
                    
                
                
                tiefenids = attribtiefenlist[attribname][0]
                attids = attribtiefenlist[attribname][1]
                #print "Attribut %s in Tiefe %s mit attribid %s "%(attribname,attribtiefenlist[attribname][0],attribtiefenlist[attribname][1])
                for i in range(len(attids)):
                    # ok build the attribute
                    theAttrib = DbAttribut(db=self.dbfact.db,logger=self.dbfact.logger,
                                atttypid=attids[i] , tiefenid=tiefenids[i] ,schlagid=self.schlag.schlagid,
                                geomid=aGeom.geomid,value=result[attribname])
                    self.attribs.append(theAttrib)    

    def __findAttribInSelfTiefenAttribMap(self,attribname):
        for key in self.__tiefenAttribMap.keys():
            list=self.__tiefenAttribMap[key]
            for index in list:
                entry = self.checkListBox_TiefenAttribute.GetString(index)
               # print "check %s = %s" %(attribname,entry)
                if entry == attribname:
                    return True
        return False
        
    def __updateTiefenCheckListBox(self):
        if self.__selTiefe==None:
            for i in range(self.checkListBox_TiefenAttribute.GetCount()):
                self.checkListBox_TiefenAttribute.Check(i,False)
        else:
            for i in range(self.checkListBox_TiefenAttribute.GetCount()):
                self.checkListBox_TiefenAttribute.Check(i,False)
            indices = self.__tiefenAttribMap ["%s" %self.__selTiefe]
            #print " Die Liste %r" %indices
            for j in indices :
                self.checkListBox_TiefenAttribute.Check(j,True)
        
        return
        

    def __initAttribute(self):
        # Attribute aus dem QuellTable auslesen
        # und dann ma rein in die GUI
        if self.storeObject == None:
            self.error = True
            return
        self.__attribColumnNames =[]
        self.__attribColumnTypes = []
        table = self.storeObject.Table() #dbfTable oder etwas mit gleicher API
        for col in table.Columns():
            self.__attribColumnNames.append(col.name)
            self.__attribColumnTypes.append(col.type)
        self.checkListBox_TiefenAttribute.InsertItems(self.__attribColumnNames,0)
            
            
            

    def __fillProjectionChoice(self):
        #alle ProjFiles in die dumme choiceBox stecken
        if len (self.__projFiles) <1 :
            self.error= True
            return
            
        for proj in self.__projFiles:
                self.choiceProj.Append(proj.GetFilename())
        self.choiceProj.SetSelection(0)
        self.__UpdateProjectionList(0)
    
    def __UpdateProjectionList(self,projFileIndex):
            
        if projFileIndex > len(self.__projFiles)  :
            self.error = True
            return
    
        self.listCtrl_Projection.ClearAll()
        self.listCtrl_Projection.InsertColumn(0,"Projektionen")
        self.listCtrl_Projection.SetColumnWidth(0,288)
        projFile = self.__projFiles[projFileIndex]
        #print "projFile %s" %projFile.GetFilename()
        self.__selectedProj = None
        self.__Projections = projFile.GetProjections()
        self.listCtrl_Projection.InsertStringItem(0,"<keine>" )
        for proj in self.__Projections:
           # print proj.GetName()
            index = self.listCtrl_Projection.GetItemCount()
            self.listCtrl_Projection.InsertStringItem(index,"%s" % proj.GetName())
           
        
            
        
            
        
    
 

    def __prepareSchlaglist(self, ogcHull):
        self.schlag = None        
        self.checkListBox_SchlagParent.Clear()
        self.__parentSchlaege = None
        try:
            schlag = self.dbfact.dbSchlagFromConvexHull(ogcHull) 
        
            if schlag != None:
                # Es gibt genau diesen Schlag schon, keine weitern Aktionen notwendig
                self.schlag = schlag
                self.txt_SchlagName.SetValue(self.schlag.name)
                self.__setSchlagStamp(self.schlag.datum)
                self.__fillTiefen()
                self.RunMessageBox("Schon vorhanden","Genau dieser Schlag ist bereit vorhanden")
                return
        
            schlaege = self.dbfact.dbSchlagFromConvexHullNew(ogcHull)
            if len(schlaege) > 0:
                #dieser neue schlag ueberschneidet sich mit welchen auss db
                self.__parentSchlaege = schlaege
                for i in self.__parentSchlaege:
                    self.checkListBox_SchlagParent.Append( "%s ,%s" %(i.name,i.datum))
        except :
            print "Fehler : %s kan nicht geprueft werden" %ogcHull
            self.dbfact.db.rollback()
        self.__fillTiefen()

        
    def __UpdatePreview(self):
        point = self.storeObject.Shape(0).Points()[0][0] # 1.Shape , 1.Vertice 1.Punkt fuer vorschou nutzen
        self.txt_OriginalDaten.SetValue("%s , %s"%point)
        projPoint = self.__proj(point)
        self.txt_Vorschau.SetValue("%s , %s"%projPoint)
    
    def __projList(self,list):
        retlist = []
        for i in list :
            retlist.append ( self.__proj(i) )
        return retlist
    
    def __proj(self,aPoint):
        normpoint = None
        x,y=aPoint
        if self.__selectedProj != None:
             normpoint = self.__selectedProj.Inverse(float(x),float(y) )
        else:
              normpoint = aPoint
        normx,normy=normpoint
        retpoint  = self.__outProj.Forward(float(normx),float(normy))
        retx,rety = retpoint
        return (retx,rety)        
   
    def __fillTiefen(self):
        if self.schlag == None:
            self.tiefen=None
            self.__strTiefen=[]
            return
        
        self.__tiefen = self.dbfact.dbTiefenFromSchlagId(self.schlag.schlagid)
        if self.__tiefen == None:
            return
        self.__strTiefen = ["%s"%i.tiefe for i in self.__tiefen]
        self.__tiefenAttribMap = {}
        
        self.listBox_Tiefen.Clear()
        self.listBox_Tiefen.InsertItems( self.__strTiefen,0)
        for tiefe in self.__strTiefen:
            self.__tiefenAttribMap[tiefe]=[]
        
        
   
    def __initDates(self):
        for tag in self.__gibTagWerte():
            self.choice_SchlagTag.Append("%s" %tag)
            self.choice_GruppenTag.Append("%s" %tag)
        for monat in self.__gibMonatWerte():
            self.choice_SchlagMonat.Append("%s" %monat)
            self.choice_GruppenMonat.Append("%s" %monat)
        for jahr in self.__gibJahrWerte():
            self.choice_SchlagJahr.Append("%s" %jahr)
            self.choice_GruppenJahr.Append("%s" %jahr)
        for stunde in self.__gibStundeWerte():
            self.choice_SchlagStunde.Append("%s" %stunde)
            self.choice_GruppenStunde.Append("%s" %stunde)
        for minute in self.__gibMinuteWerte():
            self.choice_SchlagMinute.Append("%s" %minute)
            self.choice_GruppenMinute.Append("%s" %minute)
        date = DateTime.now()
        timestamp = date.strftime("%Y-%m-%d %H:%M:%S")
        self.__setSchlagStamp(timestamp)
        self.__setGruppenStamp(timestamp)
    
    def __setSchlagStamp(self,timestamp):
        try:
            temp = timestamp[:-3]
           
        except:
            timestamp = "%s" %timestamp
            timestamp = timestamp[:-3]
        
        # timestamp muss diese Format haben "2004-09-19 23:23:23"
        try:
            date = DateTime.strptime(timestamp,"%Y-%m-%d %H:%M:%S" )
            self.choice_SchlagTag.SetSelection (date.day - 1)
            self.choice_SchlagMonat.SetSelection ( date.month -1 )
            self.choice_SchlagJahr.SetSelection ( date.year  -1970) 
            self.choice_SchlagStunde.SetSelection (date.hour  -1)
            self.choice_SchlagMinute.SetSelection ( date.minute -1)
        except:
            print "SaveDialog:__setSchlagStamp %s konnte nicht geparsed werden"
    
    def __setGruppenStamp(self,timestamp):
        try:
            temp = timestamp[:-3]
            
        except:
            timestamp = "%s" %timestamp
            timestamp = timestamp[:-3]
                
        # timestamp muss diese Format haben "2004-09-19 23:23:23"
        try:
            date = DateTime.strptime(timestamp,"%Y-%m-%d %H:%M:%S" )
            self.choice_GruppenTag.SetSelection (date.day - 1)
            self.choice_GruppenMonat.SetSelection ( date.month -1 )
            self.choice_GruppenJahr.SetSelection ( date.year -1970) 
            self.choice_GruppenStunde.SetSelection (date.hour  -1)
            self.choice_GruppenMinute.SetSelection ( date.minute -1)
        except:
            print "SaveDialog:__setGruppenStamp %s konnte nicht geparsed werden"
    def __getSchlagTimeStamp(self):
        tag = self.choice_SchlagTag.GetStringSelection()
        monat = self.choice_SchlagMonat.GetStringSelection()
        jahr = self.choice_SchlagJahr.GetStringSelection()
        stunde = self.choice_SchlagStunde.GetStringSelection()
        minute = self.choice_SchlagMinute.GetStringSelection()
        
        timestamp = "%s-%s-%s %s:%s:00"%(jahr,monat,tag,stunde,minute)
        #date = DateTime.strptime(timestamp,"%Y-%m-%d %H:%M:%S" )
        return timestamp
   
    def __getGruppenTimeStamp(self):
        tag = self.choice_GruppenTag.GetStringSelection()
        monat = self.choice_GruppenMonat.GetStringSelection()
        jahr = self.choice_GruppenJahr.GetStringSelection()
        stunde = self.choice_GruppenStunde.GetStringSelection()
        minute = self.choice_GruppenMinute.GetStringSelection()
        
        timestamp = "%s-%s-%s %s:%s:00"%(jahr,monat,tag,stunde,minute)
        
        #date = DateTime.strptime(timestamp,"%Y-%m-%d %H:%M:%S" )
        return timestamp
        
        
    def __gibTagWerte(self):
        return [ i for i in range (1,32) ]
    
    def __gibMonatWerte(self):
        return [ i for i in range (1,13) ]

    def __gibJahrWerte(self):
        return [ i for i in range (1970,2011) ]

    def __gibStundeWerte(self):
        return [ i for i in range (1,24) ]
        
    def __gibMinuteWerte(self):
        return [ i for i in range (1,60) ]

   
