# schleifen beschleunigen
try:
    from psyco.classes import __metaclass__
except:
    pass

class histogramBerechner:
    def __init__(self, numKlassen, wertetabelle, diskreteWerte=False):
        self.balkenwerte = []
        self.werteTabelle = wertetabelle
        self.anzahlDerKlassen = numKlassen
        
        self.colNames = []
        
        self.diskret = diskreteWerte
        
        if self.anzahlDerKlassen > 50:
            self.anzahlDerKlassen = 50
            print "Klassenanzahl zu hoch, setzte auf 50"
        elif self.anzahlDerKlassen < 2:
            self.anzahlDerKlassen = 2
            print "Klassenanzahl zu klein, setzte auf 2"
        
        self.maxMenge = 0
        
        if self.diskret != True:
            self.minWert = float(wertetabelle[0])
            self.maxWert = float(wertetabelle[0])
        
            for i in range( len(wertetabelle)):
                if wertetabelle[i] < self.minWert:
                    self.minWert = wertetabelle[i]
                if wertetabelle[i] > self.maxWert:
                    self.maxWert = wertetabelle[i]
        
            #print self.maxWert, self.minWert
            self.spanne = self.maxWert - self.minWert
            self.step = self.spanne/self.anzahlDerKlassen
        else:
            self.step = 1
            self.minWert = 0
            self.maxWert = self.anzahlDerKlassen
            
        self.spanne = 0            
        
        for i in range( self.anzahlDerKlassen ):
            self.balkenwerte.append(0)
            
    def getColNames( self ):
        if self.diskret == True:
            return self.colNames
        else:
            return []
            
    def erstelleHistogram( self ):
        feldStelle = 0
        for i in self.werteTabelle:
            feldStelle = self.findeKlasse(i)
            if feldStelle < len(self.balkenwerte):
                self.balkenwerte[ self.findeKlasse(i) ] += 1
            else:
                self.balkenwerte.append(1)
        for i in self.balkenwerte:
            if self.maxMenge < float(i):
                self.maxMenge = float(i)
        
        if self.diskret == True:       
            self.anzahlDerKlassen = len(self.colNames)
            self.maxWert = self.anzahlDerKlassen + 1
            self.spanne = self.maxWert - self.minWert
        
        #print self.maxMenge
    
    def findeKlasse( self, wert ):
        if self.diskret != True:
            wert_float = (1.0*wert-self.minWert)/self.step
            wert_int = int(wert_float)
            if wert_float == self.anzahlDerKlassen or wert_int >= self.anzahlDerKlassen:
                wert_int -= 1
        else:
            for i in range( len(self.colNames)):
                if len(wert) == len(self.colNames[i]) and wert.find(self.colNames[i])==0:
                    return i
                    
            self.colNames.append(wert)
            wert_int = len(self.colNames)-1
                
        return wert_int
    
    def getBalkenwerte( self ):
        return self.balkenwerte
