import types

class Matrix:
    def __init__(self, mat):
        self.mat = mat

    def __str__(self):
        return str(self.mat)

    def __neg__(self):
        return Matrix(map(lambda y:
            map(lambda x: -x, y), self.mat))
    
    def __add__matrix__(self, other):
        return Matrix(map(lambda ys, yo:
            map(lambda xs, xo:
                xs + xo, ys, yo), self.mat, other.mat))

    def __add__(self, other):
        if type(other) is types.InstanceType:
            return self.__add__matrix__(other)

        return Matrix(map(lambda y:
            map(lambda x: x + other, y), self.mat))

    def __sub__(self, other):
        return self + -other

    def getRow(self, irow):
        return self.mat[irow]

    def getCol(self, icol):
        return reduce(lambda i, j:
            [i[icol]] + [j[icol]], self.mat)

    def __mul__matrix__(self, other):
        newrow = []
        for irow in range(len(self.mat)):
            newcol = []
            for icol in range(len(self.mat[irow])):
                row = self.getRow(irow)
                col = other.getCol(icol)
            
                q = map(lambda i, j: i * j, row, col)
                q = reduce(lambda i, j: i + j, q)
                newcol += [q]
            newrow += [newcol]
        return newrow

    def __mul__(self, other):
        if type(other) is types.InstanceType:
            return self.__mul__matrix__(other)

        return Matrix(map(lambda y:
            map(lambda x: x * other, y), self.mat))
            
    def _L_teilMatrix( self ):
        L_field = []
        
        for irow in range(len(self.mat)):
            newrow = []
            for icol in range(len(self.mat[irow])):
                if ( icol <= irow ):
                    newrow.append( self.mat[irow][icol] )
                else:
                    newrow.append( 0 )
                
            L_field.append( newrow )
        
        return Matrix( L_field )
                
                
    def invert( self ):
        pass
        
    def transponiere( self ):
        newMat = []
        numCols = len(self.getRow(0))
        
        for col in range( numCols ):
            newMat.append( self.getCol( numCol ) )
            
        return Matrix( newMat )
            
    def pow( self, exponent ):
        resultat = self
        
        if ( exponent > 0 ):
            for i in range( exponent-1 ):
                resultat = resultat * self
        elif ( exponent == -1 ):
            resultat = self.invert()

        return resultat

#m = Matrix([[1, 2], [3, 4]])
#n = Matrix([[5, 6], [7, 8]])
#
#print -m
#print m * 2
#print m + n
#print m - n
#print m.getRow(0)
#print m.getCol(0)
#print m * n
#print m + 4
#print m * 2